VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} formletter2pdf_form 
   Caption         =   "formletter2pdf"
   ClientHeight    =   7560
   ClientLeft      =   45
   ClientTop       =   390
   ClientWidth     =   7605
   OleObjectBlob   =   "formletter2pdf_form.frx":0000
   StartUpPosition =   2  'Bildschirmmitte
End
Attribute VB_Name = "formletter2pdf_form"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' **********************************************************************************************
' formletter2pdf
'
' Copyright 2013 Christian Bartl (www.formletter2pdf.com)
'
' Licensed under the Apache License, Version 2.0 (the "License");
' you may not use this file except in compliance with the License.
' You may obtain a copy of the License at
'
' http://www.apache.org/licenses/LICENSE-2.0
'
' Unless required by applicable law or agreed to in writing, software
' distributed under the License is distributed on an "AS IS" BASIS,
' WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
' See the License for the specific language governing permissions and
' limitations under the License.
'
' This notice must appear in all copies of the script.
' **********************************************************************************************


Private Sub UserForm_Initialize()

    ' set desktop path as default value for FileLocation
    Me.filelocation.Value = CreateObject("WScript.Shell").SpecialFolders("Desktop")

End Sub


Private Sub FileLocation_choose_Click()

    ' define variables
    Dim ShellApplication As Object
    Dim BrowseFileLocation As Object

    ' create browse for folder dialog
    Set ShellApplication = CreateObject("Shell.Application")
    Set BrowseFileLocation = ShellApplication.BrowseForFolder(0, "Choose the location where the folder with the generated files should be stored.", 0, 16)
   
    ' save choosen path to FileLocation
    If BrowseFileLocation Is Nothing Then
    ElseIf BrowseFileLocation = "Desktop" Then
        Me.filelocation.Value = CreateObject("WScript.Shell").SpecialFolders("Desktop")
    Else
        Me.filelocation.Value = BrowseFileLocation.items().Item().Path
    End If
    
End Sub


Private Sub cancel_Click()

    ' quit macro
    Unload Me
    
End Sub


Private Sub create_Click()
    
    '
    ' define variables
    '
    Dim Filetype As String
    Dim Location As String
    Dim Folder As String
    Dim Filename As String
    Dim Path As String
    Dim Tstamp As String
    Dim Counter As Integer
    Dim EmptyCounter As Integer
    Dim isDir As Integer
    Dim File As String
    Dim Targetfile As String


    '
    ' get values from form
    '
    
        ' get filetype
    Filetype = "pdf"
    If Me.filetype_docx.Value = True Then Filetype = "docx"
    
        ' get FileLocation
    If Me.filelocation.Value = "" Then
        MsgBox "Please provide a storage location where the generated files can be saved to.", vbOKOnly + vbCritical
        Exit Sub
    Else
        Location = Me.filelocation.Value
    End If
    
        ' get foldername
    If Me.foldername.Value = "" Then
        MsgBox "Please provide a folder name.", vbOKOnly + vbCritical
        Exit Sub
    Else
        Folder = Me.foldername.Value
    End If
    
        ' get Filename
    If Me.filenamepattern.Value = "" Then
        MsgBox "Please provide a file name pattern.", vbOKOnly + vbCritical
        Exit Sub
    Else
        Filename = Me.filenamepattern.Value
    End If
        
        
    '
    ' determine path and create target folder
    '
    
        ' determine storage location path
    Tstamp = Format(Now, "dd.mm.yyyy-hh.mm.ss")
    Folder = Replace(Folder, "{%timestamp%}", Tstamp)
    Path = Location & "\" & Folder & "\"
    
        ' check if target folder already exists, abort if, create if not
    isDir = Len(Dir(Path, vbDirectory))
    On Error GoTo ErrorHandling
    
    If isDir = 0 Then
        MkDir Path
        On Error GoTo ErrorHandling
    Else
        MsgBox "A folder with the given name already exists at the storage location. Please provide another folder name or change the storage location.", vbOKOnly + vbCritical
        Exit Sub
    End If
    
    

    '
    ' show info dialog and hide word application for better performance
    '
    
    If MsgBox("The process of saving the single files can take a couple of minutes, depending on the amount of files. Microsoft Word will be hidden during this time to increase the performance. Want to continue?", vbOKCancel + vbInformation) = vbCancel Then Exit Sub
    Application.Visible = False

    
    '
    ' save form letter to single files
    '
    
    Counter = 1
    
    With ActiveDocument.MailMerge
        
        ' set mail merge options
        .Destination = wdSendToNewDocument
        .SuppressBlankLines = True
        
        ' determine amount of files
        .DataSource.ActiveRecord = wdLastRecord
        RecordCount = .DataSource.ActiveRecord
        .DataSource.ActiveRecord = 1


        Do
            ' determine filename
            With .DataSource
                
                    ' replace datasource field markers
                EmptyCounter = 0
                File = Filename
                For Each Column In .DataFields
                    File = Replace(File, "{" & Column.Name & "}", Column.Value)
                    If Column.Value = "" Then EmptyCounter = EmptyCounter + 1
                Next Column
                
                    ' skip actual record if all columns of the record are empty
                If EmptyCounter = .DataFields.Count Then
                    Counter = Counter - 1
                    GoTo NextLoop
                End If
                
                    ' replace generic counter marker
                File = Replace(File, "{%counter%}", Counter)
                
                    ' replace all characters which are not allowed in Filenames (Chr(34) = ")
                File = Replace(File, "\", "")
                File = Replace(File, "/", "")
                File = Replace(File, ":", "")
                File = Replace(File, "*", "")
                File = Replace(File, "?", "")
                File = Replace(File, Chr(34), "")
                File = Replace(File, "<", "")
                File = Replace(File, ">", "")
                File = Replace(File, "|", "")
                
            End With
            
            ' surpress any mailmerge error
            .Execute Pause:=False
            
            ' save the single document
            Targetfile = Path & File & "." & Filetype
            
            If Filetype = "docx" Then
                ActiveDocument.SaveAs Filename:=Targetfile, FileFormat:=wdFormatDocumentDefault
            Else
                ActiveDocument.SaveAs Filename:=Targetfile, FileFormat:=wdFormatPDF
            End If
            
            ' close the single document
            ActiveDocument.Close False
       
            ' get next record from datasource
NextLoop:
            If .DataSource.ActiveRecord < RecordCount Then
               .DataSource.ActiveRecord = .DataSource.ActiveRecord + 1
                Counter = Counter + 1
            Else
                Exit Do
            End If
            
        Loop
    End With
    
    
    '
    ' show result and error messages and unhide word application
    '
    
ErrorHandling:

    Application.Visible = True


    If Err.Number = 75 Then
        MsgBox "You do not have proper file system rights on the given storage location. Please choose another storage location.", vbOKOnly + vbCritical
    ElseIf Err.Number = 76 Then
        MsgBox "The given location isn't a valid storage location. Please choose another storage location.", vbOKOnly + vbCritical
    ElseIf Err.Number = 4198 Then
        MsgBox "formletter2pdf has been aborted, because an invalid file name has been detected. Please check the values of the fields used in the file name pattern for invalid characters and run formletter2pdf again.", vbOKOnly + vbCritical
        Unload Me
    ElseIf Err.Number = 5852 Then
        MsgBox "formletter2pdf could not save single files, because this document isn't a form letter. Please start the mail merge function first and then run formletter2pdf again.", vbOKOnly + vbCritical
        Unload Me
    ElseIf Err.Number > 0 Then
        MsgBox "Unknown Error: " & Err.Number & " - Please try to run formletter2pdf again.", vbOKOnly + vbCritical
        Unload Me
    Else
        If Counter > 1 Then
            MsgBox Counter & " form letters exported successfully!", vbOKOnly + vbInformation
        Else
            MsgBox Counter & " form letter exported successfully!", vbOKOnly + vbInformation
        End If
        Unload Me
    End If
    
    
End Sub


